// News.java

import swarm.Globals;
import swarm.defobj.Zone;
import swarm.objectbase.SwarmObjectImpl;

import swarm.collections.ListImpl;

/**
 * The form containing a news (treated as an object)
 *
 * newses are information about the next steps in the production
 * sequence of an order
 *
 * @author Paolo Pelligra
 */
public class News extends SwarmObjectImpl{

    /** the number of the unit which sends the news */
    public int sendingUnitNumber;

    /** the number of the unit which receives the news */
    public int receivingUnitNumber;

    /** the order announced in the news */
    public Order incomingOrderInNews;

    /** a flag about being cleared by the inventoryRuleMaster */
    boolean notClearedByInventoryRuleMaster;

    /** the step in which the news is sent (a news can be sent twice or more for
     *  different steps)
     */
    public int numberOfTheStepForWhichANewsIsSent;

    /**
     * the constructor for News
     */
    public News (Zone aZone, int su, int ru, Order or)
     {

	// call the constructor for the News parent class
        super(aZone);

        int i;
        sendingUnitNumber=su;
	receivingUnitNumber=ru;
        incomingOrderInNews= or;
        notClearedByInventoryRuleMaster=true;
        numberOfTheStepForWhichANewsIsSent =
	    incomingOrderInNews.getNumberOfTheStepForWhichANewsIsSent();

        // to check the values assigned to a news
        if(StartESFrame.verbose)
	 System.out.println("News: unit# " + sendingUnitNumber +
	       " is announcing to unit # " + receivingUnitNumber+ 
               " order # " + incomingOrderInNews.getOrderNumber() + 
               "with recipe and state:");
        if(StartESFrame.verbose){
         for (i=1;i<=incomingOrderInNews.getStepNumber();i++)
                  System.out.print(
		    incomingOrderInNews.orderRecipe[i-1] + " ");
                  System.out.println();
		 for (i=1;i<=incomingOrderInNews.stepNumber;i++)
	          System.out.print(incomingOrderInNews.orderState[i-1] + " ");
	}
    }

    /**
     * the news is now cleared by the inventoryRuleMaster
     */
    public void setClearedByInventoryRuleMaster()
    {
	notClearedByInventoryRuleMaster=false;
    }

    /**
     * return the notClearedByInventoryRuleMaster boolean value
     */
    public boolean getNotCleared()
    {
    return notClearedByInventoryRuleMaster;
    }

   /**
    * returning the sequential number of the recipe referring to which
    * the news has been sent
    */
    public int getNumberOfTheStepForWhichANewsIsSent () {

	return numberOfTheStepForWhichANewsIsSent;
  }
}
