// ProcurementSpecificationSet.java

import swarm.Globals;
import swarm.defobj.Zone;
import swarm.objectbase.SwarmObjectImpl;


/**
 * The container generated by an order and containing the spefications about
 * procument necessities
 *
 * @author Pietro Terna
 */
public class ProcurementSpecificationSet  extends SwarmObjectImpl{

    /** number (i.e. that of the order which has generated this object */
    public int myOrderNumber;
    /** the position of this sequence in the recipe */
    public int pos;
    /** the specifications */
    public int [] specifications;

  /**
   * constructor for ProcurementSpecificationSet
   */
  public ProcurementSpecificationSet (Zone aZone, int n, int p) {

     // Call the constructor for the parent class
     super(aZone);

     myOrderNumber=n;
     pos=p;

	if(StartESFrame.verbose)
     System.out.println("Proc. spec. created " +
			"(by order " + myOrderNumber + " at pos. " + 
			pos + "; NB first pos. is 0)");
  }

    /** setting the procurement specifications */
    public void setSpecificationSet(int jj, int [] r)
    {
	int i;
	specifications = new int[r[jj+1]];

	for (i=0; i<specifications.length; i++) 
	    specifications[i] = r[jj+2+i];

	if(StartESFrame.verbose)
	{
	System.out.print("item(s) to be procured ");
	for (i=0; i<specifications.length; i++) 
	    System.out.print(specifications[i] + " ");
	System.out.println(" ");
	}

    }

    /** returning the number of items to be procured */
    public int getNumberOfItemsToBeProcured(){
	return specifications.length;
    }

    /** returning the item to be procured at pos. i of the vector 
     *  containg the items (0<=i<specifications.length) */
    public int getItemToBeProcured(int i){
	return specifications[i];
    }

    /**
     * returning the number of the order of this procurement specification set
     */
    public int getNumber () {
	return myOrderNumber;
   }

    /**
     * returning the position of this procurement specification set
     * into its recipe
     */
    public int getPositionInRecipe() {
	return pos;
   }

}
